// FileManager.cpp: FileManager NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FileManager.h"

#include "MeshData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

FileManager::FileManager()
{

}

FileManager::~FileManager()
{

}

void FileManager::open(MeshData *mesh)
{
	//read cloud data file and perform trianlization.
	if(file_ext == "data"){
		this->openCloud(mesh);
	}
	//read vertex data from ply file
	else if(file_ext == "ply"){
		this->openPly(mesh);
	}
	//read vertex data from ply2 file(my original format)
	else if(file_ext == "ply2"){
		this->openOriginal(mesh);
	}
	//read vertex data from obj file(may be wave-front file)
	else if(file_ext == "obj"){
		this->openWaveFront(mesh);
	}
	//mesh->normalizeScale();
	mesh->generateVertexLink();
	mesh->generateFaceLink();
}

void FileManager::setFile(FILE *file, CString file_name, CString file_ext)
{
	this->file =  file;
	this->file_name = file_name;
	this->file_ext = file_ext;
}

void FileManager::openCloud(MeshData *mesh)
{
	int vertex_N;
	fscanf(file, "%d", &vertex_N);

	mesh->setVertexCount(vertex_N);
	float p[3];
	for(int i=0; i<vertex_N; i++){
		fscanf(file, "%f", &p[0]);
		fscanf(file, "%f", &p[1]);
		fscanf(file, "%f", &p[2]);
		mesh->setVertex(i, p);
	}
	//generateFaceFromPoints();
}

void FileManager::openPly(MeshData *mesh)
{
	int vertex_N, face_N;

	fscanf(file, "%d", &vertex_N);
	mesh->setVertexCount(vertex_N);

	fscanf(file, "%d", &face_N);
	mesh->setFaceCount(face_N);

	float p[3];
	float dummy;
	for(int i=0; i<vertex_N; i++){
		fscanf(file, "%f", &p[0]);
		fscanf(file, "%f", &p[1]);
		fscanf(file, "%f", &p[2]);
		mesh->setVertex(i, p);

		//skip extra data
		fscanf(file, "%f", &dummy);
		fscanf(file, "%f", &dummy);
	}

	int f[3];
	for(i=0; i<face_N; i++){
		fscanf(file, "%f", &dummy);
		fscanf(file, "%d", &f[0]);
		fscanf(file, "%d", &f[1]);
		fscanf(file, "%d", &f[2]);
		mesh->setFace(i, f);
	}
}

void FileManager::openOriginal(MeshData *mesh)
{
	int vertex_N, face_N;

	fscanf(file, "%d", &vertex_N);
	mesh->setVertexCount(vertex_N);

	fscanf(file, "%d", &face_N);
	mesh->setFaceCount(face_N);

	float p[3];
	float dummy;
	for(int i=0; i<vertex_N; i++){
		fscanf(file, "%f", &p[0]);
		fscanf(file, "%f", &p[1]);
		fscanf(file, "%f", &p[2]);
		//p[0] *= -1;
		mesh->setVertex(i, p);
	}

	int f[3];
	for(i=0; i<face_N; i++){
		fscanf(file, "%f", &dummy);
		fscanf(file, "%d", &f[0]);
		fscanf(file, "%d", &f[1]);
		fscanf(file, "%d", &f[2]);
		mesh->setFace(i, f);
	}
}

void FileManager::openWaveFront(MeshData *mesh)
{
	/*
	char dummyS[10];
		fscanf(file, "%s", dummyS);
		fscanf(file, "%s", dummyS);
		fscanf(file, "%d", &(mesh->vertex_N));
		fscanf(file, "%s", dummyS);

		fscanf(file, "%s", dummyS);
		fscanf(file, "%s", dummyS);
		fscanf(file, "%s", dummyS);
		fscanf(file, "%d", &(mesh->face_N));
		fscanf(file, "%s", dummyS);

		mesh->vertex = new float[mesh->vertex_N][3];
		*/
}
