// H1Error.cpp: H1Error NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PolyTest.h"
#include "H1Error.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

H1Error::H1Error()
{

}

H1Error::~H1Error()
{
}

float H1Error::func(float p[])
{
	int face_N = mesh->face_N;
	int (*face)[3] = mesh->face;

	double E = 0;
	for(int i=0; i<face_N; i++){
		int i1 = 3*face[i][0];
		int i2 = 3*face[i][1];
		int i3 = 3*face[i][2];

		float c[3];
		c[0] = (p[i1] + p[i2] + p[i3])/3.0f;
		c[1] = (p[i1+1] + p[i2+1] + p[i3+1])/3.0f;
		c[2] = (p[i1+2] + p[i2+2] + p[i3+2])/3.0f;

		float v1[3], v2[3];
		v1[0] = p[i2] - p[i1];
		v1[1] = p[i2+1] - p[i1+1];
		v1[2] = p[i2+2] - p[i1+2];
		v2[0] = p[i3] - p[i1];
		v2[1] = p[i3+1] - p[i1+1];
		v2[2] = p[i3+2] - p[i1+2];

		double cv[3];
		MeshData::CROSS(cv, v1, v2);

		double a = MeshData::LENGTH(cv);
		if((float)a == 0)
			continue;
		cv[0] /= a;
		cv[1] /= a;
		cv[2] /= a;
	
		float v = f->EvaluateFunction(c);

		E += a*v*v;
continue;
		float dv[3];
		f->EvaluateGradient(c, dv);
		double len = MeshData::LENGTH(dv);
		if((float)len == 0)
			continue;
		dv[0] /= len;
		dv[1] /= len;
		dv[2] /= len;

		E += a*2.0*(1.0 + MeshData::DOT(cv, dv));
	}

	return (float)E;
}

void H1Error::dfunc(float p[], float d[])
{
	int vertex_N = mesh->vertex_N;
	int face_N = mesh->face_N;
	int (*face)[3] = mesh->face;
	
	for(int i=0; i<3*vertex_N; i++)
		d[i] = 0;

	for(i=0; i<face_N; i++){
		int i1 = 3*face[i][0];
		int i2 = 3*face[i][1];
		int i3 = 3*face[i][2];

		float c[3];
		c[0] = (p[i1] + p[i2] + p[i3])/3.0f;
		c[1] = (p[i1+1] + p[i2+1] + p[i3+1])/3.0f;
		c[2] = (p[i1+2] + p[i2+2] + p[i3+2])/3.0f;

		float v1[3], v2[3];
		v1[0] = p[i2] - p[i1];
		v1[1] = p[i2+1] - p[i1+1];
		v1[2] = p[i2+2] - p[i1+2];
		v2[0] = p[i3] - p[i1];
		v2[1] = p[i3+1] - p[i1+1];
		v2[2] = p[i3+2] - p[i1+2];	

		double cv[3];
		MeshData::CROSS(cv, v1, v2);
		double a = MeshData::LENGTH(cv);
	
		float v = f->EvaluateFunction(c);

		float dv[3];
		f->EvaluateGradient(c, dv);

		d[i1]   += (float)(2.0*a*v*dv[0]/3.0);
		d[i1+1] += (float)(2.0*a*v*dv[1]/3.0);
		d[i1+2] += (float)(2.0*a*v*dv[2]/3.0);

		d[i2]   += (float)(2.0*a*v*dv[0]/3.0);
		d[i2+1] += (float)(2.0*a*v*dv[1]/3.0);
		d[i2+2] += (float)(2.0*a*v*dv[2]/3.0);

		d[i3]   += (float)(2.0*a*v*dv[0]/3.0);
		d[i3+1] += (float)(2.0*a*v*dv[1]/3.0);
		d[i3+2] += (float)(2.0*a*v*dv[2]/3.0);
continue;
		double len = MeshData::LENGTH(dv);
		if((float)len != 0){
			dv[0] /= len;
			dv[1] /= len;
			dv[2] /= len;
		}

		//vertex i1
		float p1[3], p2[3];
		p1[0] = p[i2];
		p1[1] = p[i2+1];
		p1[2] = p[i2+2];
		p2[0] = p[i3];
		p2[1] = p[i3+1];
		p2[2] = p[i3+2];

		float cx[3], cy[3], cz[3];
		cx[0] = 0;
		cx[1] = p1[2] - p2[2];
		cx[2] = p2[1] - p1[1];
			
		cy[0] = p2[2] - p1[2];
		cy[1] = 0;
		cy[2] = p1[0] - p2[0];

		cz[0] = p1[1] - p2[1];
		cz[1] = p2[0] - p1[0];
		cz[2] = 0;

		d[i1]   += v*v*MeshData::DOT(c, cx)/a;  //(float)(-2.0*MeshData::DOT(cx, dv));
		d[i1+1] += v*v*MeshData::DOT(c, cy)/a;  //(float)(-2.0*MeshData::DOT(cy, dv));
		d[i1+2] += v*v*MeshData::DOT(c, cz)/a;  //(float)(-2.0*MeshData::DOT(cz, dv));

		//vertex i2
		p1[0] = p[i3];
		p1[1] = p[i3+1];
		p1[2] = p[i3+2];
		p2[0] = p[i1];
		p2[1] = p[i1+1];
		p2[2] = p[i1+2];

		cx[0] = 0;
		cx[1] = p1[2] - p2[2];
		cx[2] = p2[1] - p1[1];
			
		cy[0] = p2[2] - p1[2];
		cy[1] = 0;
		cy[2] = p1[0] - p2[0];

		cz[0] = p1[1] - p2[1];
		cz[1] = p2[0] - p1[0];
		cz[2] = 0;

		d[i2]   += v*v*MeshData::DOT(c, cx)/a;  
		d[i2+1] += v*v*MeshData::DOT(c, cy)/a;  
		d[i2+2] += v*v*MeshData::DOT(c, cz)/a;  

		//d[i2]   += (float)(-2.0*MeshData::DOT(cx, dv));
		//d[i2+1] += (float)(-2.0*MeshData::DOT(cy, dv));
		//d[i2+2] += (float)(-2.0*MeshData::DOT(cz, dv));

		//vertexi3
		p1[0] = p[i1];
		p1[1] = p[i1+1];
		p1[2] = p[i1+2];
		p2[0] = p[i2];
		p2[1] = p[i2+1];
		p2[2] = p[i2+2];

		cx[0] = 0;
		cx[1] = p1[2] - p2[2];
		cx[2] = p2[1] - p1[1];
			
		cy[0] = p2[2] - p1[2];
		cy[1] = 0;
		cy[2] = p1[0] - p2[0];

		cz[0] = p1[1] - p2[1];
		cz[1] = p2[0] - p1[0];
		cz[2] = 0;

		d[i3]   += v*v*MeshData::DOT(c, cx)/a;  
		d[i3+1] += v*v*MeshData::DOT(c, cy)/a;  
		d[i3+2] += v*v*MeshData::DOT(c, cz)/a;  

		//d[i3]   += (float)(-2.0*MeshData::DOT(cx, dv));
		//d[i3+1] += (float)(-2.0*MeshData::DOT(cy, dv));
		//d[i3+2] += (float)(-2.0*MeshData::DOT(cz, dv));
	}
}
