// LocalH1Error.cpp: LocalH1Error NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PolyTest.h"
#include "LocalH1Error.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

LocalH1Error::LocalH1Error()
{

}

LocalH1Error::~LocalH1Error()
{

}

float LocalH1Error::func(float p[])
{
	int degree = mesh->degree_v[index];
	int *nei = mesh->vertex_link_v[index];
	float E = 0;
	for(int i=0; i<degree; i++){
		float* p1 = mesh->vertex[nei[i]];
		float* p2 = mesh->vertex[nei[(i+1)%degree]];
		float c[3];
		c[0] = (p[0] + p1[0] + p2[0])/3.0f;
		c[1] = (p[1] + p1[1] + p2[1])/3.0f;
		c[2] = (p[2] + p1[2] + p2[2])/3.0f;

		float fv = f->EvaluateFunction(p);
		float dfv[3];
		f->EvaluateGradient(c, dfv);
		double len = MeshData::LENGTH(dfv);
		double m[3];
		if(len != 0){
			m[0] = dfv[0]/len;
			m[1] = dfv[1]/len;
			m[2] = dfv[2]/len;
		}
		else
			continue;

		float v1[3], v2[3];
		double n[3];
		MeshData::VEC(v1, p, p1);
		MeshData::VEC(v2, p, p2);
		MeshData::CROSS(n, v2, v1);
		len = MeshData::LENGTH(n);
		if(len != 0){
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;
		}
		else
			continue;
	
		//E += (float)(fv*fv + 2.0*(1.0 - MeshData::DOT(n, m)));
		//double de = MeshData::DOT(n,m);
		E += fv*fv;
	}
	return E;
}

void LocalH1Error::dfunc(float p[], float d[])
{
	int degree = mesh->degree_v[index];
	int *nei = mesh->vertex_link_v[index];
	d[0] = d[1] = d[2] = 0;
	for(int i=0; i<degree; i++){
		float* p1 = mesh->vertex[nei[i]];
		float* p2 = mesh->vertex[nei[(i+1)%degree]];
		float c[3];
		c[0] = (p[0] + p1[0] + p2[0])/3.0f;
		c[1] = (p[1] + p1[1] + p2[1])/3.0f;
		c[2] = (p[2] + p1[2] + p2[2])/3.0f;

		float fv = f->EvaluateFunction(p);
		float dfv[3];
		f->EvaluateGradient(p, dfv);

		d[0] += (float)(2.0*fv*dfv[0]/3.0);
		d[1] += (float)(2.0*fv*dfv[1]/3.0);
		d[2] += (float)(2.0*fv*dfv[2]/3.0);
continue;
		float ddfv[3][3];
		f->EvaluateDD(c, ddfv);

		double len1 = MeshData::LENGTH(dfv);
		double m[3];
		if(len1 != 0){
			m[0] = dfv[0]/len1;
			m[1] = dfv[1]/len1;
			m[2] = dfv[2]/len1;
		}
		else
			continue;

		float v1[3], v2[3];
		double n[3], cross[3];
		MeshData::VEC(v1, p, p1);
		MeshData::VEC(v2, p, p2);
		MeshData::CROSS(cross, v2, v1);
		double len2 = MeshData::LENGTH(cross);
		if(len2 != 0){
			n[0] = cross[0]/len2;
			n[1] = cross[1]/len2;
			n[2] = cross[2]/len2;
		}
		else
			continue;

		float dc[3][3];
		dc[0][0] = 0;
		dc[0][1] = -p1[2] + p2[2];
		dc[0][2] = -p2[1] + p1[1];
			
		dc[1][0] = -p2[2] + p1[2];
		dc[1][1] = 0;
		dc[1][2] = -p1[0] + p2[0];

		dc[2][0] = -p1[1] + p2[1];
		dc[2][1] = -p2[0] + p1[0];
		dc[2][2] = 0;
	
		double dm[3], dn[3], dot;
		//x coordinate
		dot = m[0]*ddfv[0][0] + m[1]*ddfv[0][1] + m[2]*ddfv[0][2];
		dm[0] = (len1*ddfv[0][0] - dot*dfv[0])/(len1*len1);
		dm[1] = (len1*ddfv[0][1] - dot*dfv[1])/(len1*len1);
		dm[2] = (len1*ddfv[0][2] - dot*dfv[2])/(len1*len1);

		dot = n[0]*dc[0][0] + n[1]*dc[0][1] + n[2]*dc[0][2];
		dn[0] = 0;
		dn[1] = (len2*dc[0][1] - dot*cross[1])/(len2*len2);
		dn[2] = (len2*dc[0][2] - dot*cross[2])/(len2*len2);

		d[0] += -2.0f*(MeshData::DOT(dm, n) + MeshData::DOT(n, dm));

		//y coordinate
		dot = m[0]*ddfv[1][0] + m[1]*ddfv[1][1] + m[2]*ddfv[1][2];
		dm[0] = (len1*ddfv[1][0] - dot*dfv[0])/(len1*len1);
		dm[1] = (len1*ddfv[1][1] - dot*dfv[1])/(len1*len1);
		dm[2] = (len1*ddfv[1][2] - dot*dfv[2])/(len1*len1);

		dn[0] = (len2*dc[1][0] -
			(n[0]*dc[1][0] + n[1]*dc[1][1] + n[2]*dc[1][2])*cross[0])/(len2*len2);
		dn[1] = 0;
		dn[2] = (len2*dc[1][2] -
			(n[0]*dc[1][0] + n[1]*dc[1][1] + n[2]*dc[1][2])*cross[2])/(len2*len2);

		d[1] += -2.0f*(MeshData::DOT(dm, n) + MeshData::DOT(n, dm));

		//z coordinate
		dot = m[0]*ddfv[2][0] + m[1]*ddfv[2][1] + m[2]*ddfv[2][2];
		dm[0] = (len1*ddfv[2][0] - dot*dfv[0])/(len1*len1);
		dm[1] = (len1*ddfv[2][1] - dot*dfv[1])/(len1*len1);
		dm[2] = (len1*ddfv[2][2] - dot*dfv[2])/(len1*len1);

		dn[0] = (len2*dc[2][0] -
			(n[0]*dc[2][0] + n[1]*dc[2][1] + n[2]*dc[2][2])*cross[0])/(len2*len2);
		dn[1] = (len2*dc[2][1] -
			(n[0]*dc[2][0] + n[1]*dc[2][1] + n[2]*dc[2][2])*cross[1])/(len2*len2);
		dn[2] = 0;

		d[2] += -2.0f*(MeshData::DOT(dm, n) + MeshData::DOT(n, dm));
	}
}
