// LocalTangentError.h: LocalTangentError NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOCALTANGENTERROR_H__63DB03A6_FD04_48CB_B144_A00F4A56C2AA__INCLUDED_)
#define AFX_LOCALTANGENTERROR_H__63DB03A6_FD04_48CB_B144_A00F4A56C2AA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Energy.h"

class LocalTangentError  : public Energy  
{
public:
	LocalTangentError();
	virtual ~LocalTangentError();

	void dfunc(float p[], float d[]);
	float func(float p[]);

	double *Q;

	static inline double Q_ERR(double A[10], float v[3]){
		return v[0]*(A[0]*v[0] + A[1]*v[1] + A[2]*v[2]) +
			   v[1]*(A[1]*v[0] + A[3]*v[1] + A[4]*v[2]) +
			   v[2]*(A[2]*v[0] + A[4]*v[1] + A[5]*v[2]) +
			   2.0*(A[6]*v[0] + A[7]*v[1] + A[8]*v[2]) + 
			   A[9];
	}

	static inline void MAT_BY_VEC(float v[3], double A[10], float b[3]){
		v[0] = A[0]*b[0] + A[1]*b[1] + A[2]*b[2];
		v[1] = A[1]*b[0] + A[3]*b[1] + A[4]*b[2];
		v[2] = A[2]*b[0] + A[4]*b[1] + A[5]*b[2];
	}
};

#endif // !defined(AFX_LOCALTANGENTERROR_H__63DB03A6_FD04_48CB_B144_A00F4A56C2AA__INCLUDED_)
