// MeshData.cpp: MeshData NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MeshData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define PI 3.14159265

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////



MeshData::MeshData()
{
	face_N = 0;
	vertex_N = 0;

	vertex = NULL;
	face = NULL;

	vertex_link_v = NULL;
	vertex_link_f = NULL;

	degree_v = NULL;
	degree_f = NULL;

	face_link_E = NULL;

	face_link_V_N = NULL;
	face_link_V = NULL;

	isBound = NULL;

	isRidge = NULL;
	isRavine = NULL;

	ridge_tri = NULL;
	ravine_tri = NULL;

	ridge_edge = NULL;
	ravine_edge = NULL;
	
	normal = NULL;
	normal_f = NULL;

	K = NULL;
	midK = 0;
	varience = 0;

	k_max = NULL;
	k_min = NULL;
	
	t_max = NULL;
	t_min = NULL;

	k_edge = NULL;

	ridge_dir = NULL;
	ravine_dir = NULL;

	isFixed = NULL;

	//edge_list = NULL;
}

MeshData::~MeshData()
{
	this->deleteLinkData();
	/*
	if(vertex != NULL)
		delete[] vertex;

	if(face != NULL)
		delete[] face;

	if(isBound != NULL)
		delete[] isBound;

	if(vertex_link_v != NULL){
		for(int i=0; i<vertex_N; i++){
			if(vertex_link_v[i] != NULL)
				delete[] vertex_link_v[i];
		}
		delete[] vertex_link_v;
		delete[] degree_v;
	}

	if(vertex_link_f != NULL){
		for(int i=0; i<vertex_N; i++){
			if(vertex_link_f[i] != NULL)
				delete[] vertex_link_f[i];
		}
		delete[] vertex_link_f;
		delete[] degree_f;
	}

	if(face_link_E != NULL)
		delete[] face_link_E;

	if(face_link_V_N != NULL)
		delete[] face_link_V_N;

	if(face_link_V != NULL){
		for(int i=0; i<face_N; i++)
			if(face_link_V[i] != NULL)
				delete[] face_link_V[i];
		delete[] face_link_V;
	}

	if(normal != NULL)
		delete[] normal;

	if(normal_f != NULL)
		delete[] normal_f;

	if(k_max != NULL)
		delete[] k_max;

	if(k_min != NULL)
		delete[] k_min;
	
	if(t_max != NULL)
		delete[] t_max;

	if(t_min != NULL)
		delete[] t_min;

	if(isRidge != NULL)
		delete[] isRidge;

	if(isRavine != NULL)
		delete[] isRavine;

	if(ridge_dir != NULL)
		delete[] ridge_dir;

	if(ravine_dir != NULL)
		delete[] ravine_dir;

	if(ridge_edge != NULL){
		for(int i=0; i<vertex_N; i++)
			delete ridge_edge[i];
	}
	delete[] ridge_edge;
	if(ravine_edge != NULL){
		for(int i=0; i<vertex_N; i++)
			delete ravine_edge[i];
	}
	delete[] ravine_edge;*/
}

void MeshData::setVertexCount(int vertex_N)
{
	if(vertex != NULL)
		delete[] vertex;
	this->vertex_N = vertex_N;
	vertex = new float[vertex_N][3];

	if(isFixed != NULL)
		delete[] isFixed;
	isFixed = new bool[vertex_N];
}

void MeshData::setFaceCount(int face_N)
{
	if(face != NULL)
		delete[] face;
	this->face_N = face_N;
	face = (int (*)[3])new int[face_N][3];
}

int MeshData::getVertexCount()
{
	return vertex_N;
}

int MeshData::getFaceCount()
{
	return face_N;
}

void MeshData::setVertex(int index, float coordinates[3])
{
	vertex[index][0] = coordinates[0];
	vertex[index][1] = coordinates[1];
	vertex[index][2] = coordinates[2];
}

void MeshData::setFace(int index, int vertex_index[])
{
	face[index][0] = vertex_index[0];
	face[index][1] = vertex_index[1];
	face[index][2] = vertex_index[2];
}

void MeshData::getVertex(int index, float coordinates[3])
{
	coordinates[0] = vertex[index][0];
	coordinates[1] = vertex[index][1];
	coordinates[2] = vertex[index][2];
}

void MeshData::getFace(int index, int vertex_index[])
{
	vertex_index[0] = face[index][0];
	vertex_index[1] = face[index][1];
	vertex_index[2] = face[index][2];
}

void MeshData::normalizeScale()
{
	float max[3], min[3];
	max[0] = max[1] = max[2] = -1000000;
	min[0] = min[1] = min[2] = 1000000;
	for(int i=0; i<vertex_N; i++){
		for(int j=0; j<3; j++){
			if(max[j] < vertex[i][j])
				max[j] = vertex[i][j];
			else if(min[j] > vertex[i][j])
				min[j] = vertex[i][j];
		}
	}
	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];

	float scale = sizeX;
	if(scale < sizeY)
		scale = sizeY;
	if(scale < sizeZ)
		scale = sizeZ;
	scale = 40.0f/scale; //20.0f/scale;

	for(i=0; i<vertex_N; i++){
		vertex[i][0] = (vertex[i][0]-0.5f*(max[0]+min[0]))*scale;
		vertex[i][1] = (vertex[i][1]-0.5f*(max[1]+min[1]))*scale;
		vertex[i][2] = (vertex[i][2]-0.5f*(max[2]+min[2]))*scale;// + 5.0f; //10.0f;
	}
}

int MeshData::countValidVertex()
{
	int counter = 0;
	for(int i=0; i<vertex_N; i++)
		if(degree_v[i] != 0)
			counter++;
	return counter;
}

int MeshData::countValidFace()
{
	int counter = 0;
	for(int i=0; i<face_N; i++)
		if(face[i][0] != -1)
			counter++;
	return counter;
}

void MeshData::generateVertexLink()
{
	/*
	Node** vertex_link;
	//allocate memory
	vertex_link = new Node*[vertex_N];
	for(int i=0; i<vertex_N; i++)
		vertex_link[i] = new Node;

	for(i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;

		vertex_link[face[i][0]]->append(face[i][1], i);
		vertex_link[face[i][0]]->append(face[i][2], i);

		vertex_link[face[i][1]]->append(face[i][2], i);
		vertex_link[face[i][1]]->append(face[i][0], i);

		vertex_link[face[i][2]]->append(face[i][0], i);
		vertex_link[face[i][2]]->append(face[i][1], i);
	}
	*/

	int* link_N = new int[vertex_N];
	for(int i=0; i<vertex_N; i++)
		link_N[i] = 0;
	for(i=0; i<face_N; i++){
		for(int j=0; j<3; j++){
			if(face[i][j] < 0 || face[i][j] >= vertex_N)
				face[i][0] = face[i][1] = face[i][2] = -1;
			if(face[i][j] == face[i][(j+1)%3])
				face[i][0] = face[i][1] = face[i][2] = -1;
		}
	}

	for(i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;
		link_N[face[i][0]]++;
		link_N[face[i][1]]++;
		link_N[face[i][2]]++;
	}
	int** link = new int*[vertex_N];
	for(i=0; i<vertex_N; i++){
		link[i] = new int[link_N[i]*3];
		link_N[i] = 0;
	}
	for(i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;
		for(int j=0; j<3; j++){
			int index = face[i][j];
			if(index < 0)
				continue;
			link[index] [3*link_N[index]] = face[i][(j+1)%3];
			link[index] [3*link_N[index]+1] = face[i][(j+2)%3];
			link[index] [3*link_N[index]+2] = i;
			link_N[index]++;
		}
	}

	if(vertex_link_v != NULL){
		for(i=0; i<vertex_N; i++)
			if(degree_v[i] != 0)
				delete[] vertex_link_v[i];
		delete[] vertex_link_v;
		delete[] degree_v;
	}
	vertex_link_v = new int*[vertex_N];
	degree_v = new int[vertex_N];

	if(vertex_link_f != NULL){
		for(i=0; i<vertex_N; i++)
			if(degree_f[i] != 0)
				delete[] vertex_link_f[i];
			delete[] vertex_link_f;
	}
	vertex_link_f = new int*[vertex_N];
	degree_f = new int[vertex_N];

	if(isBound != NULL)
		delete[] isBound;
	isBound = new BOOL[vertex_N];

		

	for(i=0; i<vertex_N; i++){
		isBound[i] = this->sortVertexLink(link[i], link_N[i], vertex_link_v[i], vertex_link_f[i], 
										  degree_v[i], degree_f[i]);
		if(link_N[i] != 0)
			delete[] link[i];
		/*
		isBound[i] = this->sortVertexLink(vertex_link[i], vertex_link_v[i], vertex_link_f[i], 
										  degree_v[i], degree_f[i]);
										  */
	}
	/*
	for(i=0; i<vertex_N; i++){
		delete vertex_link[i];
	}*/
	delete[] link;
	delete[] link_N;
	//delete[] vertex_link;
}

void MeshData::generateFaceLink()
{
	if(face_link_E != NULL)
		delete[] face_link_E;

	face_link_E = (int (*)[3])new int[face_N][3];
	for(int i=0; i<face_N; i++)
		face_link_E[i][0] = face_link_E[i][1] = face_link_E[i][2] = -1;

	for(i=0; i<vertex_N; i++){
		if(isBound[i] == INNER){
			int* link_f = vertex_link_f[i];
			int* link_v = vertex_link_v[i];
			int f = degree_f[i];
			for(int j=0; j<f; j++){
				if(face[link_f[j]][0] == i)
					face_link_E[link_f[j]][2] = link_f[(j+1)%f];
				else if(face[link_f[j]][1] == i)
					face_link_E[link_f[j]][0] = link_f[(j+1)%f];
				else
					face_link_E[link_f[j]][1] = link_f[(j+1)%f];

				if(isBound[link_v[(j+1)%f]] == NON_MANIFOLD){
					if(face[link_f[(j+1)%f]][0] == i)
						face_link_E[link_f[(j+1)%f]][0] = link_f[j];
					else if(face[link_f[(j+1)%f]][1] == i)
						face_link_E[link_f[(j+1)%f]][1] = link_f[j];
					else
						face_link_E[link_f[(j+1)%f]][2] = link_f[j];
				}
			}
		}
		else if(isBound[i] == BOUNDARY){
			int* link_f = vertex_link_f[i];
			int* link_v = vertex_link_v[i];
			int f = degree_f[i];
			for(int j=0; j<f-1; j++){
				if(face[link_f[j]][0] == i)
					face_link_E[link_f[j]][2] = link_f[j+1];
				else if(face[link_f[j]][1] == i)
					face_link_E[link_f[j]][0] = link_f[j+1];
				else
					face_link_E[link_f[j]][1] = link_f[j+1];

				if(isBound[link_v[j+1]] == NON_MANIFOLD){
					if(face[link_f[j+1]][0] == i)
						face_link_E[link_f[j+1]][0] = link_f[j];
					else if(face[link_f[j+1]][1] == i)
						face_link_E[link_f[j+1]][1] = link_f[j];
					else
						face_link_E[link_f[j+1]][2] = link_f[j];
				}
			}
		}
	}
}


void MeshData::get1Ring(int index, int *&nei, int &nei_N)
{
	nei_N = degree_v[index];
	nei = vertex_link_v[index];
}

void MeshData::computeFaceNormal()
{
	if(normal_f != NULL)
		delete[] normal_f;
	normal_f = new float[face_N][3];
	for(int i=0; i<face_N; i++){
		float v1[3], v2[3];
		double n[3];
		double length;
		VEC(v1, vertex[face[i][0]], vertex[face[i][1]]);
		VEC(v2, vertex[face[i][0]], vertex[face[i][2]]);
		CROSS(n, v1, v2);
		length = LENGTH(n);
		if((float)length != 0){
			normal_f[i][0] = (float)(n[0]/length);
			normal_f[i][1] = (float)(n[1]/length);
			normal_f[i][2] = (float)(n[2]/length);
		}
		else
			normal_f[i][0] = normal_f[i][1] = normal_f[i][2] = 0.0f;
	}
}

void MeshData::computeNormal()
{
	if(normal != NULL)
		delete[] normal;
	normal = new float[vertex_N][3];

	double (*tmp)[3] = new double[vertex_N][3];
	for(int i=0; i<vertex_N; i++)
		tmp[i][0] = tmp[i][1] = tmp[i][2] = 0;

	for(i=0; i<face_N; i++){
		int *f = face[i];
		double area = AREA(vertex[f[0]], vertex[f[1]], vertex[f[2]]);
		float v1[3], v2[3];
		double c[3];
		VEC(v1, vertex[f[1]], vertex[f[0]]);
		VEC(v2, vertex[f[2]], vertex[f[0]]);
		CROSS(c, v1, v2);

		tmp[f[0]][0] += c[0];
		tmp[f[0]][1] += c[1];
		tmp[f[0]][2] += c[2];

		tmp[f[1]][0] += c[0];
		tmp[f[1]][1] += c[1];
		tmp[f[1]][2] += c[2];

		tmp[f[2]][0] += c[0];
		tmp[f[2]][1] += c[1];
		tmp[f[2]][2] += c[2];
	}

	for(i=0; i<vertex_N; i++){
		double length = LENGTH(tmp[i]);
		if((float)length != 0){
			normal[i][0] = (float)(tmp[i][0]/length);
			normal[i][1] = (float)(tmp[i][1]/length);
			normal[i][2] = (float)(tmp[i][2]/length);
		}
		else
			normal[i][0] = normal[i][1] = normal[i][2] = 0.0f;
	}

	delete[] tmp;
}

void MeshData::laplacian(int index, double* L)
{
	L[0] = L[1] = L[2] = 0;
	int n = degree_v[index];
	if(n == 0)
		return;
	int* link_v = vertex_link_v[index];
	for(int i=0; i<n; i++){
		L[0] += vertex[link_v[i]][0];
		L[1] += vertex[link_v[i]][1];
		L[2] += vertex[link_v[i]][2];
	}
	L[0] = L[0]/(double)n - (double)vertex[index][0];
	L[1] = L[1]/(double)n - (double)vertex[index][1];
	L[2] = L[2]/(double)n - (double)vertex[index][2];
}

void MeshData::meanCurvatureNormal(int index, double *Hn)
{
	Hn[0] = Hn[1] = Hn[2] = 0;
	if(isBound[index] != INNER)
		return;

	double A = 0;
	int n = degree_v[index];
	int* link_v = vertex_link_v[index];
	for(int i=0; i<n; i++){
		int t = link_v[i];
		int s = link_v[(i+1)%n];

		//vectors of edges of triangles
		float PQ1[3], PQ2[3], QQ[3];
		VEC(PQ1, vertex[index], vertex[s]);
		VEC(PQ2, vertex[index], vertex[t]);
		VEC(QQ, vertex[s], vertex[t]);

		//normal vector of triangle
		double n[3];
		CROSS(n, PQ1, PQ2); 

		//area of triangle
		double Ai = AREA(vertex[index], vertex[s], vertex[t]);
		
		if((float)Ai != 0){ //> 0.001){
			A += 0.5*Ai;

			double dot1 = DOT(PQ1, QQ);
			double dot2 = -DOT(PQ2,QQ);

			double cot1 = dot2/Ai;
			double cot2 = dot1/Ai;

			Hn[0] += cot1*PQ1[0] + cot2*PQ2[0];
			Hn[1] += cot1*PQ1[1] + cot2*PQ2[1];
			Hn[2] += cot1*PQ1[2] + cot2*PQ2[2];
		}
	}
	if((float)A != 0){ //> 0.006){
		Hn[0] /= A;
		Hn[1] /= A;
		Hn[2] /= A;
	}
	else{
		Hn[0] = 0;
		Hn[1] = 0;
		Hn[2] = 0;
	}
}

void MeshData::computePrincipal()
{
	if(k_max != NULL){
		delete[] k_max;
	}
	k_max = new double[vertex_N];

	if(k_min != NULL){
		delete[] k_min;
	}
	k_min = new double[vertex_N];

	if(t_max != NULL){
		delete[] t_max;
	}
	t_max = new double[vertex_N][3];

	if(t_min != NULL){
		delete[] t_min;
	}
	t_min = new double[vertex_N][3];

	if(normal == NULL)
		computeNormal();

	for(int i=0; i<vertex_N; i++){
		int nei_N, *nei;
		getConsistent1Ring(i, nei, nei_N);
		if(nei_N == 0){
			k_max[i] = k_min[i] = 0;
			t_max[i][0] = t_max[i][1] = t_max[i][2] = 0;
			t_min[i][0] = t_min[i][1] = t_min[i][2] = 0;
			continue;
		}

		if(nei_N < 3){
			k_max[i] = k_min[i] = 0;
			t_max[i][0] = t_max[i][1] = t_max[i][2] = 0;
			t_min[i][0] = t_min[i][1] = t_min[i][2] = 0;
			continue;
		}

		//generate weights 
		double total_w = 0;
		double* w = new double[nei_N];
		if(isBound[i]){
			w[0] = AREA(vertex[i], vertex[nei[0]], vertex[nei[1]]);
			total_w += w[0];
			for(int j=1; j<nei_N-1; j++){
				w[j] = AREA(vertex[i], vertex[nei[j]], vertex[nei[j-1]])
					+ AREA(vertex[i], vertex[nei[j]], vertex[nei[(j+1)%nei_N]]);
				total_w += w[j];
			}
			w[nei_N-1] = AREA(vertex[i], vertex[nei[nei_N-2]], vertex[nei[nei_N-1]]);
			total_w += w[nei_N-1]; 
		}
		else{
			for(int j=0; j<nei_N; j++){
				w[j] = AREA(vertex[i], vertex[nei[j]], vertex[nei[(j+nei_N-1)%nei_N]])
					+ AREA(vertex[i], vertex[nei[j]], vertex[nei[(j+1)%nei_N]]);
				total_w += w[j];
			}
		}

		double M[3][3];
		M[0][0] = M[0][1] = M[0][2] = M[1][0] = M[1][1] = M[1][2] = M[2][0] = M[2][1] = M[2][2] = 0;

		for(int m=0; m<nei_N; m++){
			int j = nei[m];
			float v[3];
			VEC(v, vertex[j], vertex[i]);

			//directinal curvature
			double ki = 2.0*DOT(v,normal[i])/(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);

			
			//another approximation of directinal curvature
			
			//float in = DOT(normal[i], normal[j]);
			//if(in > 1)
				//in = 1;
			//else if (in < -1)
				//in = -1;
			//float ki = -acos(in)/LENGTH(v);
			

			//tangent 
			double t[3];
			t[0] = (1.0-normal[i][0]*normal[i][0])*v[0] 
				- normal[i][0]*normal[i][1]*v[1] - normal[i][0]*normal[i][2]*v[2];
			t[1] = -normal[i][0]*normal[i][1]*v[0] + (1.0-normal[i][1]*normal[i][1])*v[1] 
				- normal[i][1]*normal[i][2]*v[2];
			t[2] = -normal[i][0]*normal[i][2]*v[0] - normal[i][1]*normal[i][2]*v[1] 
				+ (1.0-normal[i][2]*normal[i][2])*v[2];

			
			//another approximation of directinal curvature
			//if concave then -1 times
			//if(DOT(normal[j],t) < 0)
				//ki = -ki;

			double len = LENGTH(t);
			if((float)len != 0){
				t[0] /= len;
				t[1] /= len;
				t[2] /= len;

				for(int row=0; row<3; row++)
					for(int column=0; column<3; column++)
						M[row][column] += w[m]*ki*t[row]*t[column];
			}			
		}
		delete[] w;

		//normalize weight
		for(int j=0; j<3; j++)
			for(int k=0; k<3; k++)
				M[j][k] /= total_w;

		double e1[3] = {1.0, 0.0, 0.0};
		double W[3];
		if(normal[i][0] < 0){
			W[0] = (1.0 - normal[i][0])/sqrt(2.0-2.0*normal[i][0]);
			W[1] = -normal[i][1]/sqrt(2.0-2.0*normal[i][0]);
			W[2] = -normal[i][2]/sqrt(2.0-2.0*normal[i][0]);
		}
		else{
			W[0] = (1.0 + normal[i][0])/sqrt(2.0+2.0*normal[i][0]);
			W[1] = normal[i][1]/sqrt(2.0+2.0*normal[i][0]);
			W[2] = normal[i][2]/sqrt(2.0+2.0*normal[i][0]);
		}
		double Q[3][3];
		for(int row=0; row<3; row++)
			for(int column=0; column<3; column++)
				if(row != column)
					Q[row][column] = -2.0*W[row]*W[column];
				else
					Q[row][column] = 1.0 - 2.0*W[row]*W[column];
		double T1[3] = {Q[1][0], Q[1][1], Q[1][2]};
		double T2[3] = {Q[2][0], Q[2][1], Q[2][2]};

		double M2[2][2];
		M2[0][0] = M[0][0]*Q[0][1]*Q[0][1] + 2.0f*M[0][1]*Q[0][1]*Q[1][1]
			     + M[1][1]*Q[1][1]*Q[1][1] + 2.0f*M[0][2]*Q[0][1]*Q[1][2]
			     + 2.0f*M[1][2]*Q[1][1]*Q[1][2] + M[2][2]*Q[1][2]*Q[1][2];

		M2[0][1] = Q[0][2]*(M[0][0]*Q[0][1] + M[0][1]*Q[1][1] + M[0][2]*Q[1][2])
			     + Q[1][2]*(M[0][1]*Q[0][1] + M[1][1]*Q[1][1] + M[1][2]*Q[1][2])
			     + Q[2][2]*(M[0][2]*Q[0][1] + M[1][2]*Q[1][1] + M[2][2]*Q[1][2]);
		M2[1][0] = M2[0][1];

		M2[1][1] = M[0][0]*Q[0][2]*Q[0][2] + 2.0f*M[0][1]*Q[0][2]*Q[1][2] 
			     + M[1][1]*Q[1][2]*Q[1][2] + 2.0f*M[0][2]*Q[0][2]*Q[2][2]
				 + M[2][2]*Q[2][2]*Q[2][2] + 2.0f*M[1][2]*Q[1][2]*Q[2][2];

		double th = 0;
		if(M2[0][1] != 0)
			th = 0.5*(M2[1][1]-M2[0][0])/M2[0][1];
		double t = 1.0/(fabs(th)+sqrt(th*th+1));
		if(th < 0)
			t = -t;
		double cos = 1.0/sqrt(t*t+1);
		double sin = t*cos;
		
		double K1_tmp = M2[0][0] - t*M2[0][1];
		double K2_tmp = M2[1][1] + t*M2[0][1];

		double K1 = 3.0*K1_tmp - K2_tmp;
		double K2 = 3.0*K2_tmp - K1_tmp;
		
		if(K1 > K2){
			k_max[i] = K1;
			t_max[i][0] = cos*T1[0] - sin*T2[0];
			t_max[i][1] = cos*T1[1] - sin*T2[1];
			t_max[i][2] = cos*T1[2] - sin*T2[2];

			k_min[i] = K2;
			t_min[i][0] = sin*T1[0] + cos*T2[0];
			t_min[i][1] = sin*T1[1] + cos*T2[1];
			t_min[i][2] = sin*T1[2] + cos*T2[2];
		}
		else{
			k_min[i] = K1;
			t_min[i][0] = cos*T1[0] - sin*T2[0];
			t_min[i][1] = cos*T1[1] - sin*T2[1];
			t_min[i][2] = cos*T1[2] - sin*T2[2];

			k_max[i] = K2;
			t_max[i][0] = sin*T1[0] + cos*T2[0];
			t_max[i][1] = sin*T1[1] + cos*T2[1];
			t_max[i][2] = sin*T1[2] + cos*T2[2];
		}
	}
	for(i=0; i<vertex_N; i++){
		double n[3];
		CROSS(n, normal[i], t_max[i]);
		if(DOT(n, t_min[i])< 0){
			t_min[i][0] = -t_min[i][0];
			t_min[i][1] = -t_min[i][1];
			t_min[i][2] = -t_min[i][2];
		}	
	}
}

void MeshData::computeRidgeDirection()
{
	int i;
	double* dk_max = new double[vertex_N];
	double* dk_min = new double[vertex_N];

	if(ridge_dir == NULL)
		ridge_dir = new double[vertex_N][3];
	if(ravine_dir == NULL)
		ravine_dir = new double[vertex_N][3];

	for(i=0; i<vertex_N; i++){
		if(isBound[i]){
			continue;
		}
	
		int *nei_v, nei_N;
		this->getConsistent1Ring(i, nei_v, nei_N);
		if(nei_N == 0)
			continue;

		double k_max_max1, k_max_max2;
		double k_min_min1, k_min_min2;
		double l_max1, l_max2, l_min1, l_min2;

		double n1[3];
		CROSS(n1, normal[i], t_max[i]);
		double n2[3];
		CROSS(n2, normal[i], t_min[i]);

		for(int m=0; m<nei_N; m++){
			int j = nei_v[m];
			int k = nei_v[(m+1)%nei_N];

			float t1[3];
			VEC(t1, vertex[j], vertex[i]);
			float t2[3];
			VEC(t2, vertex[k], vertex[i]);

			double in1 = DOT(n1, t1);
			double in2 = DOT(n1, t2);
			if(in1 * in2 <= 0){
				double v[3];
				BOOL isOne = true;
				if(in1 < 0)
					in1 = -in1;
				if(in2 < 0){
					in2 = -in2;
					isOne = false;
				}
				v[0] = (in2*t1[0] + in1*t2[0])/(in1 + in2);
				v[1] = (in2*t1[1] + in1*t2[1])/(in1 + in2);
				v[2] = (in2*t1[2] + in1*t2[2])/(in1 + in2);

				float o[3] = {0,0,0};
				double area1 = AREA(o, t1, v);
				double area2 = AREA(o, t2, v);
				double k_max_in = (area2*k_max[j] + area1*k_max[k])/(area1+area2);
			
				if(isOne){
					k_max_max1 = k_max_in;
					l_max1 = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
				}
				else{
					k_max_max2 = k_max_in;
					l_max2 = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
				}
			}

			in1 = DOT(n2, t1);
			in2 = DOT(n2, t2);
			if(in1 * in2 <= 0){
				double v[3];
				BOOL isOne = true;
				if(in1 < 0)
					in1 = -in1;
				if(in2 < 0){
					in2 = -in2;
					isOne = false;
				}
				v[0] = (in2*t1[0] + in1*t2[0])/(in1 + in2);
				v[1] = (in2*t1[1] + in1*t2[1])/(in1 + in2);
				v[2] = (in2*t1[2] + in1*t2[2])/(in1 + in2);

				float o[3] = {0,0,0};
				double area1 = AREA(o, t1, v);
				double area2 = AREA(o, t2, v);
				double k_min_in = (area2*k_min[j] + area1*k_min[k])/(area1+area2);

				if(isOne){
					k_min_min1 = k_min_in;
					l_min1 = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
				}
				else{
					k_min_min2 = k_min_in;
					l_min2 = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
				}	
			}
		}

		double d1 = sqrt(l_max1);
		double d2 = sqrt(l_max2);
		dk_max[i] = (k_max_max2-k_max[i])/d2 + (k_max[i]-k_max_max1)/d1 - (k_max_max2-k_max_max1)/(d1+d2);
	
		d1 = sqrt(l_min1);
		d2 = sqrt(l_min2);
		dk_min[i] = (k_min_min2-k_min[i])/d2 + (k_min[i]-k_min_min1)/d1 - (k_min_min2-k_min_min1)/(d1+d2);
	}

	for(i=0; i<vertex_N; i++){
		if(isBound[i])
			continue;

		int *nei, nei_N;
		this->getConsistent1Ring(i, nei, nei_N);
		if(nei_N == 0)
			continue;

		double k_max_max1, k_max_max2, k_max_min1, k_max_min2;
		double k_min_min1, k_min_min2, k_min_max1, k_min_max2;
		double l_max1, l_max2, l_min1, l_min2;

		double n1[3];
		CROSS(n1, normal[i], t_max[i]);
		double n2[3];
		CROSS(n2, normal[i], t_min[i]);

		for(int m=0; m<nei_N; m++){
			int j = nei[m];
			int k = nei[(m+1)%nei_N];

			float t1[3];
			VEC(t1, vertex[j], vertex[i]);
			float t2[3];
			VEC(t2, vertex[k], vertex[i]);

			
			double in1 = DOT(n1, t1);
			double in2 = DOT(n1, t2);
			if(in1 * in2 <= 0){
				double v[3];
				BOOL isOne = true;
				if(in1 < 0)
					in1 = -in1;
				if(in2 < 0){
					in2 = -in2;
					isOne = false;
				}
				v[0] = (in2*t1[0] + in1*t2[0])/(in1 + in2);
				v[1] = (in2*t1[1] + in1*t2[1])/(in1 + in2);
				v[2] = (in2*t1[2] + in1*t2[2])/(in1 + in2);

				float o[3] = {0,0,0};
				double area1 = AREA(o, t1, v);
				double area2 = AREA(o, t2, v);

				double dk_max1 = dk_max[j];
				double dk_min1 = dk_min[j];
				if(DOT(t_max[i], t_max[j])<0){
					dk_max1 = -dk_max1;
					dk_min1 = -dk_min1;
				}
				
				double dk_max2 = dk_max[k];
				double dk_min2 = dk_min[k];
				if(DOT(t_max[i], t_max[k])<0){
					dk_max2 = -dk_max2;
					dk_min2 = -dk_min2;
				}

				double k_max_in = (area2*dk_max1 + area1*dk_max2)/(area1+area2);
				double k_min_in = (area2*dk_min1 + area1*dk_min2)/(area1+area2);
			
				if(isOne){
					k_max_max1 = k_max_in;
					k_min_max1 = k_min_in;
					l_max1 = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
				}
				else{
					k_max_max2 = k_max_in;
					k_min_max2 = k_min_in;
					l_max2 = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
				}
			}

			in1 = DOT(n2, t1);
			in2 = DOT(n2, t2);
			if(in1 * in2 <= 0){
				double v[3];
				BOOL isOne = true;
				if(in1 < 0)
					in1 = -in1;
				if(in2 < 0){
					in2 = -in2;
					isOne = false;
				}
				v[0] = (in2*t1[0] + in1*t2[0])/(in1 + in2);
				v[1] = (in2*t1[1] + in1*t2[1])/(in1 + in2);
				v[2] = (in2*t1[2] + in1*t2[2])/(in1 + in2);

				float o[3] = {0,0,0};
				double area1 = AREA(o, t1, v);
				double area2 = AREA(o, t2, v);

				double dk_max1 = dk_max[j];
				double dk_min1 = dk_min[j];
				if(DOT(t_min[i], t_min[j])<0){
					dk_max1 = -dk_max1;
					dk_min1 = -dk_min1;
				}
				
				double dk_max2 = dk_max[k];
				double dk_min2 = dk_min[k];
				if(DOT(t_min[i], t_min[k])<0){
					dk_max2 = -dk_max2;
					dk_min2 = -dk_min2;
				}

				double k_max_in = (area2*dk_max1 + area1*dk_max2)/(area1+area2);
				double k_min_in = (area2*dk_min1 + area1*dk_min2)/(area1+area2);

				if(isOne){
					k_min_min1 = k_min_in;
					k_max_min1 = k_max_in;
					l_min1 = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
				}
				else{
					k_min_min2 = k_min_in;
					k_max_min2 = k_max_in;
					l_min2 = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
				}	
			}
		}

		if(true){
			double d1 = sqrt(l_max1);
			double d2 = sqrt(l_max2);
		
			double a  = (k_max_max2)/d2 + (-k_max_max1)/d1 
				- (k_max_max2-k_max_max1)/(d1+d2);

			d1 = sqrt(l_min1);
			d2 = sqrt(l_min2);
		
			double b = (k_max_min2)/d2 + (-k_max_min1)/d1 
				- (k_max_min2-k_max_min1)/(d1+d2);

			ridge_dir[i][0] = b*t_max[i][0] - a*t_min[i][0];
			ridge_dir[i][1] = b*t_max[i][1] - a*t_min[i][1];
			ridge_dir[i][2] = b*t_max[i][2] - a*t_min[i][2];
	
			double len = LENGTH(ridge_dir[i]);
			ridge_dir[i][0] /= len;
			ridge_dir[i][1] /= len;
			ridge_dir[i][2] /= len;
		}

		if(true){
			double d1 = sqrt(l_min1);
			double d2 = sqrt(l_min2);
			double a = d2*(k_min_min1-dk_min[i])/(d1*(d1+d2)) - d1*(k_min_min2-dk_min[i])/(d2*(d1+d2));
			
			d1 = sqrt(l_max1);
			d2 = sqrt(l_max2);
			double b = d2*(k_min_max1-dk_min[i])/(d1*(d1+d2)) - d1*(k_min_max2-dk_min[i])/(d2*(d1+d2));

			ravine_dir[i][0] = b*t_min[i][0] - a*t_max[i][0];
			ravine_dir[i][1] = b*t_min[i][1] - a*t_max[i][1];
			ravine_dir[i][2] = b*t_min[i][2] - a*t_max[i][2];
		
			double len = LENGTH(ravine_dir[i]);
			ravine_dir[i][0] /= len;
			ravine_dir[i][1] /= len;
			ravine_dir[i][2] /= len;
		}
	}
	delete[] dk_max;
	delete[] dk_min;
}

void MeshData::getConsistent1Ring(int index, int *&nei, int &nei_N)
{
	nei_N = degree_v[index];
	nei = vertex_link_v[index];
}

int MeshData::nextFace(int face_id, int vertex_id)
{
	if(face_id < 0 || face_id >= face_N)
		return -1; 
	else if(vertex_id < 0 || vertex_id >= vertex_N)
		return -1;
	else if(face[face_id][0] == vertex_id)
		return face_link_E[face_id][2];
	else if(face[face_id][1] == vertex_id)
		return face_link_E[face_id][0];
	else if(face[face_id][2] == vertex_id)
		return face_link_E[face_id][1];
	else
		return -1;
}

int MeshData::nextVertex(int face_id, int vertex_id)
{
	if(face_id < 0 || face_id >= face_N)
		return -1; 
    else if(face[face_id][0] == vertex_id)
		return face[face_id][1];
	else if(face[face_id][1] == vertex_id)
		return face[face_id][2];
	else if(face[face_id][2] == vertex_id)
		return  face[face_id][0];
	else
		return -1;
}

int MeshData::previousFace(int face_id, int vertex_id)
{
	if(face_id < 0 || face_id >= face_N)
		return -1; 
	else if(vertex_id < 0 || vertex_id >= vertex_N)
		return -1;
	else if(face[face_id][0] == vertex_id)
		return face_link_E[face_id][0];
	else if(face[face_id][1] == vertex_id)
		return face_link_E[face_id][1];
	else if(face[face_id][2] == vertex_id)
		return face_link_E[face_id][2];
	else
		return -1;
}

double MeshData::getVolume()
{
	double vol = 0;
	double g[3],n[3],v1[3],v2[3];

	for(int i=0; i<face_N; i++){
		g[0] = (vertex[ face[i][0] ][0] + vertex[ face[i][1] ][0] + vertex[ face[i][2] ][0])/3.0;
		g[1] = (vertex[ face[i][0] ][1] + vertex[ face[i][1] ][1] + vertex[ face[i][2] ][1])/3.0;
		g[2] = (vertex[ face[i][0] ][2] + vertex[ face[i][1] ][2] + vertex[ face[i][2] ][2])/3.0;

		v1[0] = vertex[ face[i][1] ][0] - vertex[ face[i][0] ][0];
		v1[1] = vertex[ face[i][1] ][1] - vertex[ face[i][0] ][1];
		v1[2] = vertex[ face[i][1] ][2] - vertex[ face[i][0] ][2];

		v2[0] = vertex[ face[i][2] ][0] - vertex[ face[i][0] ][0];
		v2[1] = vertex[ face[i][2] ][1] - vertex[ face[i][0] ][1];
		v2[2] = vertex[ face[i][2] ][2] - vertex[ face[i][0] ][2];

		n[0] = v1[1]*v2[2] - v1[2]*v2[1];
		n[1] = v1[2]*v2[0] - v1[0]*v2[2];
		n[2] = v1[0]*v2[1] - v1[1]*v2[0];

		vol += (g[0]*n[0] + g[1]*n[1] + g[2]*n[2])/6.0;
	}
	return vol;
}

void MeshData::getConsistentNRings(int index, int n, int **&nei, int *&nei_N)
{
	/*
	Node* que = new Node;
	que->v = index;

	//In this list, f is distance(the number of edges) from the target vertex 
	Node* visit = new Node;
	visit->append(index, 0);
	visit->append(index, 0);
	
	Node* currentQ = que;
	//breath first numbering
	//this code can not compute the exact rings near boundary vertex.
	while(true){
		for(Node* currentL = vertex_link[currentQ->v]; currentL->next != NULL; currentL = currentL->next->next){
			//check if currentL->v is visited
			for(Node* currentV = visit; currentV->next != NULL; currentV = currentV->next->next){
				if(currentV->v == currentL->v)
					break;
			}
			if(currentV->next == NULL){
				//search currentQ->v from visit-list for computing distance
				for(currentV = visit; currentV->next != NULL; currentV = currentV->next->next)
					if(currentV->v == currentQ->v)
						break;
				if(currentV->f < n){
					int dist = currentV->f+1;
					for(currentV = visit; currentV->next != NULL; currentV = currentV->next->next)
						if(currentV->v == currentL->next->v)
							break;
					if(currentV->next == NULL || currentV->f == dist){
						visit->append(currentL->v, dist);
						//additinal element is appended for generating triangle data 
						visit->append(currentL->next->v, dist);

						//prepend node into que
						Node* head = new Node;
						head->v = currentL->v;
						head->next = que;
						que = head;
					}
				}
			}
		}
		if(que == currentQ){
			delete que;
			break;
		}
		for(Node* currentQ2 = que; currentQ2->next != currentQ; currentQ2 = currentQ2->next);
		currentQ2->next = NULL;
		delete currentQ;

		// currentQ is setted to tail of que
		for(currentQ = que; currentQ->next != NULL; currentQ = currentQ->next);
	}

	nei_N = new int[n];
	for(int i=0; i<n; i++)
		nei_N[i] = 0;

	for(Node* currentV = visit->next->next; currentV->next != NULL; currentV = currentV->next)
		nei_N[currentV->f-1]++;

	nei = (int **)new int[n];
	int* counter = new int[n];
	for(i=0; i<n; i++){
		nei[i] = new int[nei_N[i]];
		counter[i] = 0;
	}

	for(currentV = visit->next->next; currentV->next != NULL; currentV = currentV->next){
		nei[currentV->f-1][counter[currentV->f-1]++] = currentV->v;
	}
	delete visit;
	delete[] counter;

	//sort ring index consistently
	for(i=0; i<n; i++){
		int bound_flag = -1;
		for(int j=0; j<nei_N[i]; j+=2){
			if(isBound[nei[i][j]]){
				bound_flag = j;
				break;
			}
		}
		if(bound_flag >= 0){
			int tmp1 = nei[i][0];
			int tmp2 = nei[i][1];
			nei[i][0] = nei[i][bound_flag];
			nei[i][1] = nei[i][bound_flag+1];
			nei[i][bound_flag] = tmp1;
			nei[i][bound_flag+1] = tmp2;
		}
		for(j=0; j<nei_N[i]-2; j+=2){
			int pair = nei[i][j+1];
			for(int k=j+2; k<nei_N[i]; k+= 2){
				if(pair == nei[i][k]){
					int tmp1 = nei[i][k];
					int tmp2 = nei[i][k+1];
					nei[i][k] = nei[i][j+2];
					nei[i][k+1] = nei[i][j+3];
					nei[i][j+2] = tmp1;
					nei[i][j+3] = tmp2;
				}
			}
		}
		int *nei_tmp = new int[nei_N[i]/2];
		for(j=0; j<nei_N[i]; j+=2)
			nei_tmp[j/2] = nei[i][j];
		delete nei[i];
		nei[i] = nei_tmp;
		nei_N[i] /= 2;
	}
	*/
}	

BOOL MeshData::getConsistent1Ring(int index, int *&nei_v, int *&nei_f, int &nei_N)
{
	nei_N = degree_v[index];
	nei_v = vertex_link_v[index];
	nei_f = vertex_link_f[index];

	if(isBound[index] == NON_MANIFOLD)
		return false;
	else
		return true;
}

void MeshData::deleteFace(int index)
{
	if(index < 0 || index >= face_N)
		return;

	for(int i=0; i<3; i++){
		int pair = face_link_E[index][i];
		if(pair >= 0){
			if(face_link_E[pair][0] == index)
				face_link_E[pair][0] = -1;
			else if(face_link_E[pair][1] == index)
				face_link_E[pair][1] = -1;
			else if(face_link_E[pair][2] == index)
				face_link_E[pair][2] = -1;
			face_link_E[index][i] = -1;
		}
	}
	face[index][0] = -1;
	face[index][1] = -1;
	face[index][2] = -1;
}

void MeshData::generateFaceLinkV()
{
	if(face_link_V_N != NULL)
		delete[] face_link_V_N;

	if(face_link_V != NULL){
		for(int i=0; i<vertex_N; i++)
			if(face_link_V[i] != NULL)
				delete[] face_link_V[i];
		delete[] face_link_V;
	}

	face_link_V_N = new int[face_N];
	face_link_V = new int*[face_N];
	for(int i=0; i<vertex_N; i++)
		face_link_V[i] = NULL;

	for(i=0; i<face_N; i++){
		face_link_V_N[i] = 0;
		Node* list = new Node;
		for(int j=0; j<3; j++){
			int v = face[i][j];
			int *nei_v, *nei_f, nei_N;
			getConsistent1Ring(v, nei_v, nei_f, nei_N);
			if(nei_N == 0)
				continue;
			if(isBound[v])
				nei_N--;
			for(int k=0; k<nei_N; k++){
				if(nei_f[k] != i 
					&& nei_f[k] != face_link_E[i][0]
						&& nei_f[k] != face_link_E[i][1]
							&& nei_f[k] != face_link_E[i][2]){
					list->append(-1, nei_f[k]);
					face_link_V_N[i]++;
				}
				
			}
		}
		if(face_link_V_N[i] != 0){
			face_link_V[i] = new int[face_link_V_N[i]];
			Node* current = list;
			for(j=0; j<face_link_V_N[i]; j++){
				face_link_V[i][j] = current->f;
				current = current->next;
			}
		}
		delete list;
	}
}

float MeshData::minEdge()
{
	double min = 1000000;
	for(int i=0; i<vertex_N; i++){
		int n = degree_v[i];
		int* link_v = vertex_link_v[i];
		for(int j=0; j<n; j++){
			if(i > link_v[j]){
				float v[3];
				VEC(v, vertex[i], vertex[link_v[j]]);
				double len = sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
				if((float)len != 0 && min > len)
					min = len;
			}
		}
	}
	return (float)min;
}

void MeshData::copyMesh(MeshData *mesh)
{
	setVertexCount(mesh->vertex_N);
	for(int i=0; i<vertex_N; i++){
		vertex[i][0] = mesh->vertex[i][0];
		vertex[i][1] = mesh->vertex[i][1];
		vertex[i][2] = mesh->vertex[i][2];
	}

	setFaceCount(mesh->face_N);
	for(i=0; i<face_N; i++){
		face[i][0] = mesh->face[i][0];
		face[i][1] = mesh->face[i][1];
		face[i][2] = mesh->face[i][2];
	}
}

void MeshData::allocateTagEdges()
{
	if(ridge_edge != NULL){
		for(int i=0; i<vertex_N; i++)
			delete ridge_edge[i];
	}
	delete[] ridge_edge;
	if(ravine_edge != NULL){
		for(int i=0; i<vertex_N; i++)
			delete ravine_edge[i];
	}
	delete[] ravine_edge;

	ridge_edge = new Node*[vertex_N];
	ravine_edge = new Node*[vertex_N];

	for(int i=0; i<vertex_N; i++){
		ridge_edge[i] = new Node;
		ravine_edge[i] = new Node;
	}
}

void MeshData::rescale(double rate)
{
	for(int i=0; i<vertex_N; i++){
		vertex[i][0] = (float)(rate*vertex[i][0]);
		vertex[i][1] = (float)(rate*vertex[i][1]);;
		vertex[i][2] = (float)(rate*vertex[i][2]);
	}
}

int MeshData::sortVertexLink(Node *link, int *&link_v, int *&link_f, int &v, int &f)
{
	//count incident face
	f = 0;
	for(Node* current=link; current->next!=NULL; current=current->next->next)
		f++;
	//if no face is incident, then the point is isolated.
	if(f == 0){
		v = 0;
		link_v = NULL;
		link_f = NULL;
		return NON_MANIFOLD;
	}

	//un-sorted adjacent vertex data
	link_f = new int[f];
	int *link_v_tmp = new int[2*f];
	int i = 0;
	for(current=link; current->next!=NULL; current=current->next->next){
		link_v_tmp[2*i] = current->v;
		link_v_tmp[2*i+1] = current->next->v;
		link_f[i] = current->f;
		i++;
	}

	//check topology
	int b_even = 0;
	int b_odd = 0;
	int b_index;
	for(i=0; i<f; i++){
		int target = link_v_tmp[2*i];
		int consist = 0;
		for(int j=0; j<f; j++){
			if(target == link_v_tmp[2*j+1]){
				consist++;
				
			}
		}
		if(consist != 1){
			b_index = i;
			b_even++;
		}

		target = link_v_tmp[2*i+1];
		consist = 0;
		for(j=0; j<f; j++){
			if(target == link_v_tmp[2*j])
				consist++;
		}
		if(consist != 1)
			b_odd++;
	}
	int type;
	if(b_even == 0 && b_odd == 0){
		//the vertex is inner
		type = INNER;
		v = f;

		//sort tmp data by using boble sort
		for(i=0; i<f-1; i++){
			int target = link_v_tmp[2*i+1];
			for(int j=i+1; j<f; j++){
				if(target == link_v_tmp[2*j]){
					int tmp = link_v_tmp[2*i+2];
					link_v_tmp[2*i+2] = link_v_tmp[2*j];
					link_v_tmp[2*j] = tmp;

					tmp = link_v_tmp[2*i+3];
					link_v_tmp[2*i+3] = link_v_tmp[2*j+1];
					link_v_tmp[2*j+1] = tmp;

					tmp = link_f[i+1];
					link_f[i+1] = link_f[j];
					link_f[j] = tmp;

					break;
				}
			}
		}
		link_v = new int[v];
		for(i=0; i<v; i++)
			link_v[i] = link_v_tmp[2*i];
	}
	else if(b_even == 1 && b_odd == 1){
		//the vertex is boundary
		type = BOUNDARY;
		v = f+1;
		
		//swap head data
		int tmp = link_v_tmp[0];
		link_v_tmp[0] = link_v_tmp[2*b_index];
		link_v_tmp[2*b_index] = tmp;

		tmp = link_v_tmp[1];
		link_v_tmp[1] = link_v_tmp[2*b_index+1];
		link_v_tmp[2*b_index+1] = tmp;

		tmp = link_f[0];
		link_f[0] = link_f[b_index];
		link_f[b_index] = tmp;

		//sort tmp data by using boble sort
		for(i=0; i<f-1; i++){
			int target = link_v_tmp[2*i+1];
			for(int j=i+1; j<f; j++){
				if(target == link_v_tmp[2*j]){
					tmp = link_v_tmp[2*i+2];
					link_v_tmp[2*i+2] = link_v_tmp[2*j];
					link_v_tmp[2*j] = tmp;

					tmp = link_v_tmp[2*i+3];
					link_v_tmp[2*i+3] = link_v_tmp[2*j+1];
					link_v_tmp[2*j+1] = tmp;

					tmp = link_f[i+1];
					link_f[i+1] = link_f[j];
					link_f[j] = tmp;

					break;
				}
			}
		}

		link_v = new int[v];
		for(i=0; i<f; i++)
			link_v[i] = link_v_tmp[2*i];
		link_v[i] = link_v_tmp[2*f-1];
	}
	else{
		//the vertex is a non-manifold point
		type =  NON_MANIFOLD;
		v = 2*f;
		link_v = new int[v];
		for(i=0; i<v; i++)
			link_v[i] = link_v_tmp[i];
	}

	delete[] link_v_tmp;
	return type;
}

void MeshData::deleteLinkData()
{
	if(vertex != NULL)
		delete[] vertex;

	if(face != NULL)
		delete[] face;

	if(isBound != NULL)
		delete[] isBound;

	if(vertex_link_v != NULL){
		for(int i=0; i<vertex_N; i++){
			if(vertex_link_v[i] != NULL)
				delete[] vertex_link_v[i];
		}
		delete[] vertex_link_v;
		delete[] degree_v;
	}

	if(vertex_link_f != NULL){
		for(int i=0; i<vertex_N; i++){
			if(vertex_link_f[i] != NULL)
				delete[] vertex_link_f[i];
		}
		delete[] vertex_link_f;
		delete[] degree_f;
	}

	if(face_link_E != NULL)
		delete[] face_link_E;

	if(face_link_V_N != NULL)
		delete[] face_link_V_N;

	if(face_link_V != NULL){
		for(int i=0; i<face_N; i++)
			if(face_link_V[i] != NULL)
				delete[] face_link_V[i];
		delete[] face_link_V;
	}

	if(normal != NULL)
		delete[] normal;

	if(normal_f != NULL)
		delete[] normal_f;

	if(k_max != NULL)
		delete[] k_max;

	if(k_min != NULL)
		delete[] k_min;
	
	if(t_max != NULL)
		delete[] t_max;

	if(t_min != NULL)
		delete[] t_min;

	if(isRidge != NULL)
		delete[] isRidge;

	if(isRavine != NULL)
		delete[] isRavine;

	if(ridge_dir != NULL)
		delete[] ridge_dir;

	if(ravine_dir != NULL)
		delete[] ravine_dir;

	if(k_edge != NULL)
		delete[] k_edge;

	if(ridge_edge != NULL){
		for(int i=0; i<vertex_N; i++)
			delete ridge_edge[i];
	}
	delete[] ridge_edge;
	if(ravine_edge != NULL){
		for(int i=0; i<vertex_N; i++)
			delete ravine_edge[i];
	}
	delete[] ravine_edge;

	face_N = 0;
	vertex_N = 0;

	vertex = NULL;
	face = NULL;

	vertex_link_v = NULL;
	vertex_link_f = NULL;

	degree_v = NULL;
	degree_f = NULL;

	face_link_E = NULL;

	face_link_V_N = NULL;
	face_link_V = NULL;

	isBound = NULL;

	isRidge = NULL;
	isRavine = NULL;

	ridge_tri = NULL;
	ravine_tri = NULL;

	ridge_edge = NULL;
	ravine_edge = NULL;
	
	normal = NULL;
	normal_f = NULL;

	K = NULL;
	midK = 0;
	varience = 0;

	k_max = NULL;
	k_min = NULL;
	
	t_max = NULL;
	t_min = NULL;

	k_edge = NULL;

	ridge_dir = NULL;
	ravine_dir = NULL;

	if(isFixed != NULL)
		delete[] isFixed;

	isFixed = NULL;
}

int MeshData::sortVertexLink(int *link, int N, int *&link_v, int *&link_f, int &v, int &f)
{
	//count incident face
	f = N;
	//if no face is incident, then the point is isolated.
	if(f == 0){
		v = 0;
		link_v = NULL;
		link_f = NULL;
		return NON_MANIFOLD;
	}

	//un-sorted adjacent vertex data
	link_f = new int[f];
	int *link_v_tmp = new int[2*f];
	for(int i=0; i<N; i++){
		link_v_tmp[2*i] = link[3*i];
		link_v_tmp[2*i+1] = link[3*i+1];
		link_f[i] = link[3*i+2];
	}

	int b_index = -1;
	for(i=0; i<f; i++){
		int target = link_v_tmp[2*i];
		for(int j=0; j<f; j++)
			if(target == link_v_tmp[2*j+1])
				break;
		if(j == f)
			b_index = i;
	}
	if(b_index != -1){
		int tmp = link_v_tmp[0];
		link_v_tmp[0] = link_v_tmp[2*b_index];
		link_v_tmp[2*b_index] = tmp;

		tmp = link_v_tmp[1];
		link_v_tmp[1] = link_v_tmp[2*b_index+1];
		link_v_tmp[2*b_index+1] = tmp;

		tmp = link_f[0];
		link_f[0] = link_f[b_index];
		link_f[b_index] = tmp;
	}
	//sort tmp data by using boble sort
	for(i=0; i<f-1; i++){
		int target = link_v_tmp[2*i+1];
		for(int j=i+1; j<f; j++){
			if(target == link_v_tmp[2*j]){
				int tmp = link_v_tmp[2*i+2];
				link_v_tmp[2*i+2] = link_v_tmp[2*j];
				link_v_tmp[2*j] = tmp;

				tmp = link_v_tmp[2*i+3];
				link_v_tmp[2*i+3] = link_v_tmp[2*j+1];
				link_v_tmp[2*j+1] = tmp;

				tmp = link_f[i+1];
				link_f[i+1] = link_f[j];
				link_f[j] = tmp;

				break;
			}
		}
		if(j == f)
			b_index = -2;
	}
	if(b_index < 0 && link_v_tmp[0] != link_v_tmp[2*f-1])
		b_index = -2;
	if(b_index == -1){
		for(i=0; i<f; i++){
			int target = link_v_tmp[2*i];
			int consist = 0;
			for(int j=0; j<f; j++){
				if(target == link_v_tmp[2*j+1]){
					consist++;		
				}
			}
			if(consist != 1){
				b_index = -2;
				break;
			}
		}
	}
	else if(b_index >= 0){
		for(i=1; i<f; i++){
			int target = link_v_tmp[2*i];
			int consist = 0;
			for(int j=0; j<f; j++){
				if(target == link_v_tmp[2*j+1]){
					consist++;		
				}
			}
			if(consist != 1){
				b_index = -2;
				break;
			}
		}
	}

/*
	//check topology
	int b_even = 0;
	int b_odd = 0;
	int b_index;
	for(i=0; i<f; i++){
		int target = link_v_tmp[2*i];
		int consist = 0;
		for(int j=0; j<f; j++){
			if(target == link_v_tmp[2*j+1]){
				consist++;
				
			}
		}
		if(consist != 1){
			b_index = i;
			b_even++;
		}

		target = link_v_tmp[2*i+1];
		consist = 0;
		for(j=0; j<f; j++){
			if(target == link_v_tmp[2*j])
				consist++;
		}
		if(consist != 1)
			b_odd++;
	}
	*/
	int type;
	//if(b_even == 0 && b_odd == 0){
	if(b_index == -1){
		//the vertex is inner
		type = INNER;
		v = f;
/*
		//sort tmp data by using boble sort
		for(i=0; i<f-1; i++){
			int target = link_v_tmp[2*i+1];
			for(int j=i+1; j<f; j++){
				if(target == link_v_tmp[2*j]){
					int tmp = link_v_tmp[2*i+2];
					link_v_tmp[2*i+2] = link_v_tmp[2*j];
					link_v_tmp[2*j] = tmp;

					tmp = link_v_tmp[2*i+3];
					link_v_tmp[2*i+3] = link_v_tmp[2*j+1];
					link_v_tmp[2*j+1] = tmp;

					tmp = link_f[i+1];
					link_f[i+1] = link_f[j];
					link_f[j] = tmp;

					break;
				}
			}
		}*/
		link_v = new int[v];
		for(i=0; i<v; i++)
			link_v[i] = link_v_tmp[2*i];
	}
	else if(b_index == -2){
		//the vertex is a non-manifold point
		type =  NON_MANIFOLD;
		v = 2*f;
		link_v = new int[v];
		for(i=0; i<v; i++)
			link_v[i] = link_v_tmp[i];
	}
	//else if(b_even == 1 && b_odd == 1){
	else{
		//the vertex is boundary
		type = BOUNDARY;
		v = f+1;
		/*
		//swap head data
		int tmp = link_v_tmp[0];
		link_v_tmp[0] = link_v_tmp[2*b_index];
		link_v_tmp[2*b_index] = tmp;

		tmp = link_v_tmp[1];
		link_v_tmp[1] = link_v_tmp[2*b_index+1];
		link_v_tmp[2*b_index+1] = tmp;

		tmp = link_f[0];
		link_f[0] = link_f[b_index];
		link_f[b_index] = tmp;

		//sort tmp data by using boble sort
		for(i=0; i<f-1; i++){
			int target = link_v_tmp[2*i+1];
			for(int j=i+1; j<f; j++){
				if(target == link_v_tmp[2*j]){
					tmp = link_v_tmp[2*i+2];
					link_v_tmp[2*i+2] = link_v_tmp[2*j];
					link_v_tmp[2*j] = tmp;

					tmp = link_v_tmp[2*i+3];
					link_v_tmp[2*i+3] = link_v_tmp[2*j+1];
					link_v_tmp[2*j+1] = tmp;

					tmp = link_f[i+1];
					link_f[i+1] = link_f[j];
					link_f[j] = tmp;

					break;
				}
			}
		}*/

		link_v = new int[v];
		for(i=0; i<f; i++)
			link_v[i] = link_v_tmp[2*i];
		link_v[i] = link_v_tmp[2*f-1];
	}
	/*
	else{
		//the vertex is a non-manifold point
		type =  NON_MANIFOLD;
		v = 2*f;
		link_v = new int[v];
		for(i=0; i<v; i++)
			link_v[i] = link_v_tmp[i];
	}*/

	delete[] link_v_tmp;
	return type;
}


void MeshData::faceCenter(double c[], int f)
{
	int i1 = face[f][0];
	int i2 = face[f][1];
	int i3 = face[f][2];
	c[0] = (vertex[i1][0] + vertex[i2][0] + vertex[i3][0])/3.0;
	c[1] = (vertex[i1][1] + vertex[i2][1] + vertex[i3][1])/3.0;
	c[2] = (vertex[i1][2] + vertex[i2][2] + vertex[i3][2])/3.0;
}

double MeshData::faceArea(int f)
{
	return AREA(vertex[face[f][0]], vertex[face[f][1]], vertex[face[f][2]]);
}

void MeshData::computeEdgeCurvature()
{
	if(k_edge != NULL)
		delete[] k_edge;
	k_edge = new double[face_N][3];
	if(normal_f == NULL)
		computeFaceNormal();

	for(int i=0; i<face_N; i++){
		for(int j=0; j<3; j++){
			double c[3];
			faceCenter(c, i);
			double a = faceArea(i);
			int pair = face_link_E[i][j];
			if(pair < 0){
				k_edge[i][j] = 0;
				continue;
			}
			else if(i > pair){
				double dot = DOT(normal_f[i], normal_f[pair]);
				if(dot > 1.0)
					dot = 1.0;
				else if(dot < -1.0)
					dot = -1.0;
				double a1 = faceArea(pair);
				double l = DIST(vertex[face[i][j]], vertex[face[i][(j+1)%3]]);
				if((float)a != 0 && (float)a1 != 0)
					k_edge[i][j] = acos(dot)*l/(a+a1);
				else
					k_edge[i][j] = 0;

				double c1[3];
				faceCenter(c1, pair);
				double v[3];
				MeshData::VEC(v, c, c1);
				double len = MeshData::LENGTH(v);
				double dot1, dot2;
				if((float)len != 0){
					dot1 = MeshData::DOT(v, normal_f[i])/len;
					dot2 = -MeshData::DOT(v, normal_f[pair])/len;
				}
				else{
					dot1 = 1;
					dot2 = 1;
				}

				if(dot1 > 1.0)
					dot1 = 1.0;
				else if(dot1 < -1.0)
					dot1 = -1.0;
				if(dot2 > 1.0)
					dot2 = 1.0;
				else if(dot2 < -1.0)
					dot2 = -1.0;
				double angle = acos(dot1) + acos(dot2);
				if(angle < PI)
					k_edge[i][j] = -k_edge[i][j];

				if(face_link_E[pair][0] == i)
					k_edge[pair][0] = k_edge[i][j];
				else if(face_link_E[pair][1] == i)
					k_edge[pair][1] = k_edge[i][j];
				else
					k_edge[pair][2] = k_edge[i][j];
			}
		}
	}
}

void MeshData::copyMesh2(MeshData *mesh)
{
	int f_N = mesh->countValidFace();
	int v_N = mesh->countValidVertex();
	int* vertex_table = new int[mesh->vertex_N];
	
	setVertexCount(v_N);
	int counter = 0;
	for(int i=0; i<mesh->vertex_N; i++){
		if(mesh->degree_v[i] != 0){
			vertex[counter][0] = mesh->vertex[i][0];
			vertex[counter][1] = mesh->vertex[i][1];
			vertex[counter][2] = mesh->vertex[i][2];
			vertex_table[i] = counter;
			counter++;
		}
		else
			vertex_table[i] = -1;
	}
	setFaceCount(f_N);
	counter = 0;
	for(i=0; i<mesh->face_N; i++){
		if(mesh->face[i][0] >= 0){
			face[counter][0] = vertex_table[mesh->face[i][0]];
			face[counter][1] = vertex_table[mesh->face[i][1]];
			face[counter][2] = vertex_table[mesh->face[i][2]];
			counter++;
		}
	}

	for(i=0; i<mesh->vertex_N; i++)
		if(vertex_table[i] >= 0)
			isFixed[vertex_table[i]] = mesh->isFixed[i];

	delete[] vertex_table;
}

void MeshData::faceCenter(float c[], int f)
{
	int i1 = face[f][0];
	int i2 = face[f][1];
	int i3 = face[f][2];
	c[0] = (vertex[i1][0] + vertex[i2][0] + vertex[i3][0])/3.0f;
	c[1] = (vertex[i1][1] + vertex[i2][1] + vertex[i3][1])/3.0f;
	c[2] = (vertex[i1][2] + vertex[i2][2] + vertex[i3][2])/3.0f;
}

void MeshData::largestComponent()
{
	int* id = new int[vertex_N];
	for(int i=0; i<vertex_N; i++)
		id[i] = -1;

	int current = 0;
	for(i=0; i<vertex_N; i++){
		if(id[i] < 0){
			establishID(i, current, id);
			current++;
		}
	}

	int* component = new int[current];
	for(i=0; i<current; i++)
		component[i] = 0;
	for(i=0; i<vertex_N; i++)
		component[id[i]]++;
	int max_id = 0;
	for(i=1; i<current; i++)
		if(component[max_id] < component[i])
			max_id = i;

	int new_vertex_N = component[max_id];
	float (*new_vertex)[3] = new float[new_vertex_N][3];
	int *index = new int[vertex_N];
	int v = 0;
	for(i=0; i<vertex_N; i++)
		if(id[i] == max_id){
			new_vertex[v][0] = vertex[i][0];
			new_vertex[v][1] = vertex[i][1];
			new_vertex[v][2] = vertex[i][2];
			index[i] = v;
			v++;
		}

	int new_face_N = 0;
	for(i=0; i<face_N; i++)
		if(id[face[i][0]] == max_id)
			new_face_N++;
	
	int (*new_face)[3] = new int[new_face_N][3];
	int f = 0;
	for(i=0; i<face_N; i++)
		if(id[face[i][0]] == max_id){
			new_face[f][0] = index[face[i][0]];
			new_face[f][1] = index[face[i][1]];
			new_face[f][2] = index[face[i][2]];
			f++;
		}

	delete[] id;
	delete[] component;
	delete[] index;
	delete[] vertex;
	delete[] face;

	vertex_N = new_vertex_N;
	face_N = new_face_N;
	vertex = new_vertex;
	face = new_face;
}

void MeshData::establishID(int v, int current_id, int *id)
{
	id[v] = current_id;
	for(int i=0; i<degree_v[v]; i++){
		if(id[vertex_link_v[v][i]] < 0)
			establishID(vertex_link_v[v][i], current_id, id);
	}
}

void MeshData::computeCenter()
{
	center = new float[face_N][3];
	for(int i=0; i<face_N; i++){
		int i1 = face[i][0];
		int i2 = face[i][1];
		int i3 = face[i][2];
		center[i][0] = (vertex[i1][0] + vertex[i2][0] + vertex[i3][0])/3.0f;
		center[i][1] = (vertex[i1][1] + vertex[i2][1] + vertex[i3][1])/3.0f;
		center[i][2] = (vertex[i1][2] + vertex[i2][2] + vertex[i3][2])/3.0f;
	}
}

void MeshData::computeVertexFromCenter()
{
	for(int i=0; i<vertex_N; i++){
		int fn = degree_f[i];
		int *link = vertex_link_f[i];
		float tmp[] = {0,0,0};
		for(int j=0; j<fn ; j++){
			tmp[0] += center[link[j]][0];
			tmp[1] += center[link[j]][1];
			tmp[2] += center[link[j]][2];
		}
		vertex[i][0] = tmp[0]/fn;
		vertex[i][1] = tmp[1]/fn;
		vertex[i][2] = tmp[2]/fn;
	}
}

double MeshData::triangleEdgeAverage(int i)
{
	int i1 = face[i][0];
	int i2 = face[i][1];
	int i3 = face[i][2];
	return (DIST(vertex[i1], vertex[i2]) 
		+ DIST(vertex[i2], vertex[i3]) 
		+ DIST(vertex[i3], vertex[i1]))/3.0;
}
